/*
 * Copyright (c) 2015, University of Kaiserslautern
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Authors:
 *    Janik Schlemminger
 *    Robert Gernhardt
 *    Matthias Jung
 */

#include "tracetesttreewidget.h"

TraceTestTreeWidget::TraceTestTreeWidget(QWidget *parent) : QTreeWidget(parent)
{
    QObject::connect(this, SIGNAL(itemSelectionChanged()), this,
                     SLOT(itemSelectionChanged()));
    setHeaderHidden(true);
}

void TraceTestTreeWidget::addTraceTestResult(const TraceTestResults
                                             &traceTestResult)
{
    QTreeWidgetItem *top = new QTreeWidgetItem({traceTestResult.getTraceName()});
    addTopLevelItem(top);

    if (traceTestResult.hasPassedAllTests())
        top->setTextColor(0, Qt::green);
    else
        top->setTextColor(0, Qt::red);

    for (const TestResult &testResult : traceTestResult.getTestResults()) {
        new TestResultTreeItem(top, testResult);
    }
}

void TraceTestTreeWidget::itemSelectionChanged()
{
    if (!selectedItems().isEmpty()
            && selectedItems().at(0)->type() ==
            TestResultTreeItem::testResultTreeItemType) {
        TestResultTreeItem *testResultItem = static_cast<TestResultTreeItem *>
                                             (selectedItems().at(0));
        Q_EMIT setMessage(testResultItem->getMessage());
    } else {
        setMessage(QString(""));
    }
}

TraceTestTreeWidget::TestResultTreeItem::TestResultTreeItem(
    QTreeWidgetItem *parent, const TestResult &testResult)
    : QTreeWidgetItem(parent, testResultTreeItemType)
{
    setText(0, testResult.getTestName());
    if (!testResult.hasPassed())
        setTextColor(0, Qt::red);
    message = testResult.getMessage();
}
